#if !defined (OGLISTA_H)
#define OGLISTA_H

#include<iostream>
#include<fstream>

#include "defs.h"
#include "ograph.h"

template<class T> std::list<T> disc_replacement(const T& o, int param, int param2=0);
template<class T> std::list<T> disc_replacement(const std::list<T>& ol, int param, int param2=1);
template<class T> void elimina_poliedri_doppi(T& ls, int num_gia_fatti=0);
template<class T> void elimina_varieta_doppie(T& ls, int profondita=0);
template<class T> void elimina_non_minimali(T& ls, int profondita_su=0, bool ua2 = FALSE, 
																						int profondita4 = -1);

template<class T> std::list<T> parenti_minimali(const T& o, int profondita_su = 0, 
																		bool usa2 = FALSE, int profondita4=-1, int profondita_giu=-1);
template<class T> std::list<T> parenti_minimali(const std::list<T>& ol, int profondita_su = 0, 
																		bool usa2 = FALSE, int profondita4=-1, int profondita_giu = -1);


void scrivi_contatore(char* w, int l, int contatore, int lung);
template<class T> void scrivi_info(const T& ol);
template<class T> void scrivi(const std::list<T>& ol, std::ostream& f = std::cout, int tipo_formato = 0);

template<class T> std::list<T> carica(std::ifstream& file, int tipo_formato = 0);
template<class T> std::list<T> carica(char* nome_file, int tipo_formato = 0);
template<class T> void salva(const std::list<T>& ls, std::ofstream& file, int tipo_formato = 0);
template<class T> void salva(const std::list<T>& ls, char* nome_file, int tipo_formato = 0,
														 bool append = FALSE);



#endif






